
from time import time, gmtime, localtime, mktime, asctime, ctime

_days = ['Su','Mo','Tu','We','Th','Fr','Sa']
_months = ['January','February','March','April','May','June','July','August','September','October','November','December']
_mdays = [31,28,31,30,31,30,31,31,30,31,30,31]

# ------------------------------------------------------------------------
def _isleap( year ):
    return year % 4 == 0 and (year % 100 <> 0 or year % 400 == 0 )

# ------------------------------------------------------------------------
def _weekday( year, month, day ):
    secs = mktime((year,month+1,day,0,0,0,0,0,0))
    t = localtime(secs)
    return t[6]

# ------------------------------------------------------------------------
def _monthrange( year, month ):
    day1 = _weekday( year, month, 1 )
    ndays = _mdays[month] + (month == 1 and _isleap(year))
    return day1, ndays

# ------------------------------------------------------------------------
def _monthcalendar( year, month ):
    day1, ndays = _monthrange( year, month )
    rows = []
    day = 1 - day1
    while day <= ndays+1:
	row = [0,0,0,0,0,0,0]
	for i in range(7):
	    if 1 < day <= ndays+1:
		row[i] = day - 1
	    day = day + 1
	rows.append(row)
    return rows
    
# ------------------------------------------------------------------------
def show_calendar( year=None, month=None ):
    t = localtime(time())
    if year == None:
	year = t[0]
    if month == None:
	month = t[1]-1
    cal = _monthcalendar( year, month )
    s = '<table border=0 cellspacing=1 cellpadding=1>'
    s = s + '<tr><td colspan=7 align=center bgcolor="#0000FF"><font color="#FFFFFF"><b>%s %d</b></font></td></tr>' % (_months[11], 1999)
    s = s + '<tr>'
    for day in _days:
	s = s + '<th>%s</th>' % day
    s = s + '</tr>'
    for week in cal:
	s = s + '<tr>'
	for day in week:
	    s = s + '<td width=14% align=center>'
	    if day:
		if day == t[2] and month == t[1]-1 and year == t[0]:
		    s = s + '<font color="#FF0000">%s</font>' % str(day)
		else:
		    s = s + '%s' % str(day)
	    s = s + '</td>'
	s = s + '</tr>'
    s = s + '</table>'
    return s

# ========================================================================
if __name__ == '__main__':
    print show_calendar( )
